/*
 * *
 *    Copyright 2011 Baptiste Wicht & Frédéric Bapst
 *
 *    Licensed under the Apache License, Version 2.0 (the "License");
 *    you may not use this file except in compliance with the License.
 *    You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 *    Unless required by applicable law or agreed to in writing, software
 *    distributed under the License is distributed on an "AS IS" BASIS,
 *    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *    See the License for the specific language governing permissions and
 *    limitations under the License.
 *
 */

package com.github.cojac.perfs.opcodes;

import java.util.concurrent.Callable;

public class DCMPCallable implements Callable<Double> {
    private double a0, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16, a17, a18, a19, a20, a21, a22, a23, a24, a25, a26, a27, a28, a29, a30, a31, a32, a33, a34, a35, a36, a37, a38, a39, a40, a41, a42, a43, a44, a45, a46, a47, a48, a49, a50, a51;

    public DCMPCallable() {
        setA00(0);
    }

    @Override
    public Double call() {
        return a0 > a1 ? a0 : a1 > a2 ? a1 : a2 > a3 ? a2 : a3 > a4 ? a3 : a4 > a5 ? a4 : a5 > a6 ? a5 : a6 > a7 ? a6 : a7 > a8 ? a7 : a8 > a9 ? a8 : a9 > a10 ? a9 : a10 > a11 ? a10 : a11 > a12 ? a11 : a12 > a13 ? a12 : a13 > a14 ? a13 : a14 > a15 ? a14 : a15 > a16 ? a15 : a16 > a17 ? a16 : a17 > a18 ? a17 : a18 > a19 ? a18 : a19 > a20 ? a19 : a20 > a21 ? a20 : a21 > a22 ? a21 : a22 > a23 ? a22 : a23 > a24 ? a23 : a24 > a25 ? a24 : a25 > a26 ? a25 : a26 > a27 ? a26 : a27 > a28 ? a27 : a28 > a29 ? a28 : a29 > a30 ? a29 : a30 > a31 ? a30 : a31 > a32 ? a31 : a32 > a33 ? a32 : a33 > a34 ? a33 : a34 > a35 ? a34 : a35 > a36 ? a35 : a36 > a37 ? a36 : a37 > a38 ? a37 : a38 > a39 ? a38 : a39 > a40 ? a39 : a40 > a41 ? a40 : a41 > a42 ? a41 : a42 > a43 ? a42 : a43 > a44 ? a43 : a44 > a45 ? a44 : a45 > a46 ? a45 : a46 > a47 ? a46 : a47 > a48 ? a47 : a48 > a49 ? a48 : a49 > a50 ? a49 : a50 > a51 ? a50 :
            a51;
        /*
 return a>b?a:b>c?b:a>b?a:b>c?b:a>b?a:b>c?b:a>b?a:b>c?b:a>b?a:b>c?b:a>b?a:b>c?b:
        a>b?a:b>c?b:a>b?a:b>c?b:a>b?a:b>c?b:a>b?a:b>c?b:a>b?a:b>c?b:a>b?a:b>c?b:
        a>b?a:b>c?b:a>b?a:b>c?b:a>b?a:b>c?b:a>b?a:b>c?b:a>b?a:b>c?b:a>b?a:b>c?b:
        a>b?a:b>c?b:a>b?a:b>c?b:a>b?a:b>c?b:a>b?a:b>c?b:a>b?a:b>c?b:a>b?a:b>c?b:
        a>b?a:b>c?b:a>b?a:b>c?b:

          a>b?a:b>c?b:a>b?a:b>c?b:a>b?a:b>c?b:a>b?a:b>c?b:a>b?a:b>c?b:a>b?a:b>c?b:
            a>b?a:b>c?b:a>b?a:b>c?b:a>b?a:b>c?b:a>b?a:b>c?b:a>b?a:b>c?b:a>b?a:b>c?b:
            a>b?a:b>c?b:a>b?a:b>c?b:a>b?a:b>c?b:a>b?a:b>c?b:a>b?a:b>c?b:a>b?a:b>c?b:
            a>b?a:b>c?b:a>b?a:b>c?b:a>b?a:b>c?b:a>b?a:b>c?b:a>b?a:b>c?b:a>b?a:b>c?b:
            a>b?a:b>c?b:a>b?a:b>c?b:

        c;
        // Maybe dangerous because of multiple evaluation of the same
        // expression, that the JVM might optimize...
        */
    }

    public void setA00(double c) {
        a0 = c + 0;
        a1 = c + 1;
        a2 = c + 2;
        a3 = c + 3;
        a4 = c + 4;
        a5 = c + 5;
        a6 = c + 6;
        a7 = c + 7;
        a8 = c + 8;
        a9 = c + 9;
        a10 = c + 10;
        a11 = c + 11;
        a12 = c + 12;
        a13 = c + 13;
        a14 = c + 14;
        a15 = c + 15;
        a16 = c + 16;
        a17 = c + 17;
        a18 = c + 18;
        a19 = c + 19;
        a20 = c + 20;
        a21 = c + 21;
        a22 = c + 22;
        a23 = c + 23;
        a24 = c + 24;
        a25 = c + 25;
        a26 = c + 26;
        a27 = c + 27;
        a28 = c + 28;
        a29 = c + 29;
        a30 = c + 30;
        a31 = c + 31;
        a32 = c + 32;
        a33 = c + 33;
        a34 = c + 34;
        a35 = c + 35;
        a36 = c + 36;
        a37 = c + 37;
        a38 = c + 38;
        a39 = c + 39;
        a40 = c + 40;
        a41 = c + 41;
        a42 = c + 42;
        a43 = c + 43;
        a44 = c + 44;
        a45 = c + 45;
        a46 = c + 46;
        a47 = c + 47;
        a48 = c + 48;
        a49 = c + 49;
        a50 = c + 50;
        a51 = c + 51
        ;
    }

    public static void main(String[] args) {
        int n = 52;
        for (int i = 0; i < n; i++)
            System.out.print(" ,a" + i);
        System.out.println();
        for (int i = 0; i < n; i++)
            System.out.print(" ;a" + i + "=c+" + i);
        System.out.println();
        for (int i = 0; i < n; i++) {
            String ai = "a" + i, aj = "a" + (i + 1);
            System.out.print(ai + ">" + aj + "?" + ai + ":");
        }
        System.out.println();
    }
}